import datetime
from typing import List
from uuid import UUID

from pydantic import BaseModel, ConfigDict

from api.product.schemas import ProductPostSchema, ProductOrderGetSchema


class OrderIdSchema(BaseModel):
    id: UUID

    model_config = ConfigDict(from_attributes=True)


class OrderPostSchema(BaseModel):
     items: List[ProductPostSchema]


class OrderGetSchema(OrderIdSchema):
    status: str
    total: float
    products: List[ProductOrderGetSchema]


class OrderStatusSchema(BaseModel):
    id: UUID
    status: str


class OrderListSchema(BaseModel):
    id: UUID
    status: str
    total: float
    created_at: datetime.datetime
    updated_at: datetime.datetime
