import fastapi as fa

from .ctrl import ProductController
from .schemas import ProductGetSchema


router = fa.APIRouter(prefix='/products', tags=['Product'])
ctrl = ProductController()


@router.post('')
async def create_product(
        image: fa.UploadFile,
        name: str = fa.Form(...),
        description: str = fa.Form(None),
        price: float = fa.Form(...)
):
    return await ctrl.create(name=name, description=description, price=price, image=image)


@router.get('')
async def get_products(page: int = 1, size: int = 10, params: ProductGetSchema = fa.Depends()):
    return await ctrl.get_list(page=page, size=size, **params.model_dump(exclude_none=True))
