from uuid import UUID

from pydantic import BaseModel, ConfigDict


class ProductBaseSchema(BaseModel):
    name: str | None = None


class ProductIdSchema(BaseModel):
    id: UUID | None = None
    model_config = ConfigDict(from_attributes=True)


class ProductGetSchema(ProductBaseSchema, ProductIdSchema):
    description: str | None = None
    price: float | None = None
    image: str | None = None


class ProductPostSchema(BaseModel):
    id: UUID
    quantity: int


class ProductOrderGetSchema(BaseModel):
    id: UUID
    price: int
    quantity: int
