import math

from .base import BaseRepository
from ..models import Order


class OrderRepository(BaseRepository):
    model = Order

    async def get_list(self, page, size, **kwargs):
        query = self.model.all()

        offset_min = (page - 1) * size
        offset_max = page * size

        data = await query
        result = {
            "page": page,
            "size": size,
            "total": math.ceil(len(data) / size) - 1,
            "result": data[offset_min:offset_max]
        }
        return result
